﻿namespace TabsStudioSorter
{
    public class Sorter : TabsStudioExt.ITabsStudioAddin
    {
        public void OnConnection(TabsStudioExt.ITabsStudioEngine engine, EnvDTE80.DTE2 dte)
        {
            engine.TabCreated += new TabsStudioExt.TabCreatedEventHandler(OnTabCreated);
        }

        public void OnDisconnection()
        {
        }

        private void OnTabCreated(object sender, TabsStudioExt.TabCreatedEventArgs e)
        {
            foreach (System.Windows.Controls.TabItem tabItem in e.TabPanel.Children)
            {
                string newTabName = GetTabNameWithoutPath(e.TabItem);
                if (tabItem != e.TabItem && 
                    System.String.Compare(GetTabNameWithoutPath(tabItem), newTabName, true) > 0)
                {
                    e.TabPanel.Children.Remove(e.TabItem);
                    e.TabPanel.Children.Insert(e.TabPanel.Children.IndexOf(tabItem), e.TabItem);
                    break;
                }
            }
        }

        private string GetTabName(System.Windows.Controls.TabItem tabItem)
        {
            System.Windows.Controls.DockPanel tabInternals = tabItem.Header as System.Windows.Controls.DockPanel;
            System.Windows.Controls.StackPanel tabNameGroup = tabInternals.Children[0] as System.Windows.Controls.StackPanel;
            System.Windows.Controls.Label tabName = tabNameGroup.Children[0] as System.Windows.Controls.Label;
            return tabName.Content as string;
        }

        private string GetTabNameWithoutPath(System.Windows.Controls.TabItem tabItem)
        {
            string tabName = GetTabName(tabItem);
            int pathEnd = tabName.LastIndexOf('/');
            return pathEnd >= 0 ? tabName.Substring(pathEnd + 1) : tabName;
        }
    }
}
